// Copyright (c) 2008,9,10 by Andrey Mirtchovski <mirtchovski@gmail.com>

/* Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * ANDREY MIRTCHOVSKI AND/OR ITS SUPPLIERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */


var currentCity = null;
var fadeTimer = null;
var currentDetails = null;
var forecastDetails = null;
var windChill = null;
var buildVersion;
var availVersion;
var updateTimer = null;
var updateInterval = null;

function setTimer(time) {
	if(updateTimer) {
		clearInterval(updateTimer);
		updateTimer = null;
	}
	updateTimer = setInterval('updateHandler()', time);
}

function stopTimer() {
	if(updateTimer) {
		clearInterval(updateTimer);
		updateTimer = null;
	}
}

// lifted from http://weather.gc.ca/
function updatecities(event) {
	var cityFieldObj = document.getElementById('locationPopup');
	var provinceFieldObj = document.getElementById('regionPopup');
	var cityList = null;
	var provincialSummary;
	var olympicSummary;
	var cityCode = ""; 
	var foundDefaultCity = 0;
	var defaultCityIndex = 0;
	var newCitySelection = document.createElement('select');
	var cities = null;
	
	if(localizedStrings['Done'] == 'Done') {
		cities = citiesEn;
	} else {
		cities = citiesFr;
	}
	
	cityFieldObj.options.length = 0; // clear options list

	cityList = cities[provinceFieldObj[provinceFieldObj.selectedIndex].value]; // grab selected English city 
	// Create city list for selected province
	for (var cityOption=0; cityOption < cityList.length; cityOption++) {
		var optionVals = cityList[cityOption].split('|');
		cityFieldObj.options[cityFieldObj.options.length] = new Option(optionVals[0], optionVals[1]);
	}

	cityFieldObj.selectedIndex = 0;
}

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();
	
    var region = document.getElementById("regionPopup");
	var locationPopup = document.getElementById("locationPopup");
	var location = document.getElementById("location");
	var bb = document.getElementById("boxBottom");
	var ds = document.getElementById("detailsScroll");
	var sl = document.getElementById("stackLayout");
	var ui = document.getElementById("updatePopup");
	
	sl.object.setCurrentView(bb, 0);

	if(localizedStrings['Done'] == 'Done') {
		region.innerHTML = canadaRegionsEn;
		locationPopup.innerHTML = '<option value="--">Select a Location</option>';
	} else {
		region.innerHTML = canadaRegionsFr;
		locationPopup.innerHTML = '<option value="--">Choisissez un endroit</option>';	
	}
	
	var img = document.getElementById("currentImg");
	img.style.opacity = 0.0;
    for(var day = 0; day < 7; day++) {
        img = document.getElementById("dayImg"+day);
        img.style.opacity = 0.0;
        img = document.getElementById("dayNImg"+day);
        img.style.opacity = 0.0;
    }
	
	//load up the user's preferences
	if(window.widget) {
		var u = widget.preferenceForKey(createInstancePreferenceKey("units"));
        if (u == null) 
            u = widget.preferenceForKey("units");
		if (u != null) {
			units = u;
		}
        
        var p = widget.preferenceForKey(createInstancePreferenceKey("selectedRegion"));
        if(p == null)
            p = widget.preferenceForKey("selectedRegion");
		if (p != null) {
			region.selectedIndex = p;
			updatecities();
		}
        
		var c = widget.preferenceForKey(createInstancePreferenceKey("selectedLocation"));
        if(c == null) 
            c = widget.preferenceForKey("selectedLocation");
		if(c != null) {
			locationPopup.selectedIndex = c;
			location.innerHTML = locationPopup.options[c].innerHTML;
			currentCity = locationPopup.options[c].value.toLowerCase();
			//refresh();
		} else {
			if(localizedStrings['Done'] == 'Done') {
				location.innerText = "Select a location";
			} else {
				location.innerText = "Choisissez une région";	
			}
		}
		var z = widget.preferenceForKey(createInstancePreferenceKey("updateSelection"));
        if(z == null)
            z = widget.preferenceForKey("updateSelection");            
		if(z != null) {
			ui.selectedIndex = z;
		} else {
			ui.selectedIndex = 0;
		}
		updateInterval = parseInt(ui.options[ui.selectedIndex].value) * 60000;
		setTimer(updateInterval);
	}
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
	stopTimer();
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
	stopTimer();
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
	refresh();
	setTimer(updateInterval);
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

	getVersion();
		
	if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

function cleanFront()
{
    /* clean up everything */
    var cl = document.getElementById('location');
    if(localizedStrings['Done'] == 'Done') {
        cl.innerText = "Select a location";
    } else {
        cl.innerText = "Choisissez une région";	
    }
    var ct = document.getElementById('currentTemp');
    ct.innerText = '';
    var tim = document.getElementById('time');
    tim.innerText = '';
    var cw = document.getElementById('currentWind');
    cw.innerText = '';
    var fl = document.getElementById('feelsLike');
    fl.innerText = '';
    var sr = document.getElementById('sunrise');
    sr.innerText = '';
    var ci = document.getElementById('currentImg');
    ci.style.opacity = 0.0;
    for(var day = 0; day < 7; day++) {
        var cimg = document.getElementById('dayImg'+day);
        cimg.style.opacity = 0.0;
        cimg = document.getElementById('dayNImg'+day);
        cimg.style.opacity = 0.0;
        var chigh = document.getElementById('dayHigh'+day);
        chigh.innerText = '';
        var clow = document.getElementById('dayLow'+day);
        clow.innerText = '';
        var cname = document.getElementById('day'+day);
        cname.innerText = '';
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
	var city = document.getElementById("locationPopup");
	var region = document.getElementById("regionPopup");
	var ui = document.getElementById("updatePopup");
    var unts = document.getElementById("units");
    var defaultlocation = document.getElementById("defaultlocation");
    if(unts.checked) {
        units = 'i';
    } else {
        units = 'm';
    }
	
	if(region.options[region.selectedIndex].value != "--") {
		var loc = document.getElementById("location");
		
		loc.innerHTML = city.options[city.selectedIndex].innerHTML;
		currentCity = city.options[city.selectedIndex].value.toLowerCase();
		
		refresh();
		if(window.widget) {
			widget.setPreferenceForKey(city.selectedIndex, createInstancePreferenceKey("selectedLocation"));
			widget.setPreferenceForKey(region.selectedIndex, createInstancePreferenceKey("selectedRegion"));
			widget.setPreferenceForKey(ui.selectedIndex, createInstancePreferenceKey("updateSelection"));
			widget.setPreferenceForKey(units, createInstancePreferenceKey("units"));
            if(defaultlocation.checked) {
                widget.setPreferenceForKey(city.selectedIndex, "selectedLocation");
                widget.setPreferenceForKey(region.selectedIndex, "selectedRegion");
                widget.setPreferenceForKey(ui.selectedIndex, "updateSelection");
                widget.setPreferenceForKey(units, "units");
            }
		}
	} else {
        cleanFront();
    }
    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

function getLanguage()
{
	if(localizedStrings['Done'] == 'Done') {
		return 'e';
	} else {
		return 'f';
	}
}

function visitCopyrightPage(event)
{
	var lang;
	if(getLanguage() == 'e') {
		lang = 'En';
	} else {
		lang = 'Fr';
	}
	var websiteURL = "http://www.ec.gc.ca/default.asp?lang="+lang+"&xml=5830C36B-1773-4E3E-AF8C-B21F54633E0A";
	widget.openURL(websiteURL);
}

function emailAuthor(event)
{
	var websiteURL = "mailto:mirtchovski@gmail.com?subject=Weather%20Office%20Widget; "+buildVersion;
	// Show website code
	widget.openURL(websiteURL);
}


function emailMouseOver(event)
{
	var text = document.getElementById("email");
	text.style.textDecoration = 'underline';
}

function emailMouseOut(event)
{
	var text = document.getElementById("email");
	text.style.textDecoration = 'none';
}

function visitWO(event)
{
	var lang;
	var websiteURL = "http://www.weather.gc.ca";
	
	if(getLanguage() == 'f') {
		websiteURL = "http://www.meteo.gc.ca";
	}
	// Show website code
	widget.openURL(websiteURL);
}

function linkMouseOver(event)
{
	var text = document.getElementById("linkWO");
	text.style.textDecoration = 'underline';
}

function linkMouseOut(event)
{
	var text = document.getElementById("linkWO");
	text.style.textDecoration = 'none';
}

function visitForecast(event)
{
    /* first, check if there's a warning and if there is, visit that instead */
    var loc = document.getElementById("location");
    if(loc.warningHTML != "") {
        widget.openURL(loc.warningHTML);
        return;
    }
    
	var city = document.getElementById("locationPopup");
	var region = document.getElementById("regionPopup");
	var lang = getLanguage();
	var websiteURL = "http://www.weather.gc.ca/";
	
	if(lang == 'f') {
		websiteURL = "http://www.meteo.gc.ca/";
	}
	
	if(region.selectedIndex > 0) {
		websiteURL += 'city/pages/' + city.options[city.selectedIndex].value.toLowerCase() + '_metric_' + lang + '.html';
		// Show website code
		widget.openURL(websiteURL);
	} else {
		showBack(null);
	}

}

function cityMouseOver(event)
{
	var text = document.getElementById("location");
	text.style.textDecoration = 'underline';
}

function cityMouseOut(event)
{
	var text = document.getElementById("location");
	text.style.textDecoration = 'none';
}

function doCity(event)
{

}

function doRegion(event)
{
	updatecities();
}

function getDOMfromXML(xml) {
	var d = document.createElement('div');
    if(xml.indexOf('<body') >= 0) {
        xml = xml.substring(xml.indexOf('<body') + xml.substring(xml.indexOf('<body')).indexOf('>')+1);
        xml = xml.substring(0, xml.indexOf('</body>'));
    }
	d.innerHTML = xml;
	
	return d;
}

function parseObservedAt(xml) {
    var idx = xml.indexOf("Observed at:</b>");
    if(idx == -1) {
        idx = xml.indexOf("Enregistrées à:</b>")
    }
    if(idx == -1) {
        return "";
    }
    xml = xml.substring(idx);
    xml = xml.substring(xml.indexOf("</b>")+4);
    xml = xml.substring(0, xml.indexOf("<br/>"));
    xml = xml.substring(xml.indexOf(":")-2);
    xml = xml.substring(0, xml.indexOf("M")+1);

    //alert(xml);
    
    return xml;
}

function translateDOW(dow) {
    if(dow == "Mon") {
        return "lun";
    } 
    if(dow == "Tue") {
        return "mar";
    }
    if(dow == "Wed") {
        return "mer";
    }
    if(dow == "Thu") {
        return "jeu";
    }    
    if(dow == "Fri") {
        return "ven";
    }    
    if(dow == "Sat") {
        return "sam";
    }    
    if(dow == "Sun") {
        return "dim";
    } 
}

function parseHumidity(xml) {
    var idx = xml.indexOf("Humidity:</b>");
    if(idx == -1) {
        return "";
    }
    xml = xml.substring(idx);
    xml = xml.substring(xml.indexOf("</b>")+4);
    xml = xml.substring(0, xml.indexOf("<br/>"));

    xml = xml.replace(/[ \n\t\r]/g, '');
    
    return xml;
}

function parseFeelsLike(xml, units) {
    var feelsLike = document.getElementById('feelsLike');
    feelsLike.innerHTML = "";

    var idx = xml.indexOf("Wind Chill:</b>");
    if(idx > -1) {
        feelsLike.style.color = "#bad3fc";
    } else {
        var idx = xml.indexOf("Humidex:</b>");
        if(idx > -1) {
            feelsLike.style.color = "#f9486b";
        } else {
            return;
        }
    }
    xml = xml.substring(idx);
    xml = xml.substring(xml.indexOf("</b>")+4);
    xml = xml.substring(0, xml.indexOf("<br/>"));

    xml = xml.replace(/[ \n\t\r]/g, '');
        
    var itemp = parseFloat(xml);
    if(units == 'i') {
        itemp = (itemp*9)/5 + 32;
    }
                    
    itemp = parseInt(Math.round(itemp));

    feelsLike.innerText = "" + itemp + "º";                
    
    return;
}

function parseFore(xml, units) {
    var forecast = xml.substring(xml.indexOf(". ") + 2);
    var reg1 = /^(High|Low)( plus| minus)? (.+)\.( POP )?([0-9]+%)?$/;
    var reg2 = /^Temperature steady near( plus| minus)? ([0-9]+).( POP )?([0-9]+%)?$/;
    var reg3 = /^[Tt]emperature (falling|rising) to( plus| minus)? ([0-9]+) .*\.( POP )?([0-9]+%)?$/;
    var temp;
    var itemp;
    var pop;

    var isLow = xml.match(/^Tonight:/);
    if(!isLow) {
        isLow = xml.match(/^[A-Z][a-z]+ night:/)
    }
  
    var match = reg1.exec(forecast);
    if(match) {
        if(match[3].indexOf("zero") == 0) {
            match[3] = '0';
        }
        
        itemp = parseFloat(match[3]);
        if(match[2] == " minus"){
            itemp = -1.0 * itemp;
        }
        if(units == 'i') {
            itemp = (itemp * 9)/5 + 32;
        }

        temp = "" + Math.round(itemp);
        return {
            temp:  temp,
            pop: match[5],
            low: isLow
        };
    }
    
    
    match = reg2.exec(forecast);
    if(match) {
        if(match[2] == "zero") {
            match[2] = '0';
        }        
        itemp = parseFloat(match[2]);
        if(match[1] == " minus"){
            itemp = -1.0 * itemp;
        }
        if(units == 'i') {
            itemp = (itemp * 9)/5 + 32;
        }
        
        temp = "" + Math.round(itemp);        
        return {
            temp:  temp,
            pop: match[4],
            low: isLow
        };
  
    }
    match = reg3.exec(forecast);
    if(match) {
        if(match[3] == "zero") {
            match[3] = '0';
        }        
        itemp = parseFloat(match[3]);
        if(match[2] == " minus"){
            itemp = -1.0 * itemp;
        }
        if(units == 'i') {
            itemp = (itemp * 9)/5 + 32;
        }
        
        temp = "" + Math.round(itemp) + "*";        
        return {
            temp:  temp,
            pop: match[5],
            low: isLow
        };
  
    }

    return null;
}


function refresh() {
	var er;
	var lang = getLanguage();
	if(currentCity == null) {
		return;
	}
    
    SimpleAJAXCall(
		'http://weather.gc.ca/rss/city/' + currentCity + '_e.xml',
		function(xml) {
            var currentDetails = "";
			var ct = document.getElementById('currentTemp');
            ct.innerHTML = '';
            
            var unts = document.getElementById("units");
            var units = 'm';
            if(unts.checked) {
                units = 'i';
            } else {
                units = 'm';
            }

			var tim = document.getElementById('time');
            var observed = parseObservedAt(xml);
            if(observed != "") {
                tim.innerText = "@" + parseObservedAt(xml);
            } else {
                tim.innerText = "";
            }
            
            var humidity = parseHumidity(xml);
            if(humidity != "") {
                tim.innerText = tim.innerText + " " + humidity + "hum.";
            }
            
            parseFeelsLike(xml, units);

			// convert the HTML to an XML DOM object
			var parser = new DOMParser();
            var nxml = parser.parseFromString(xml, "text/xml");
            // print the name of the root element or error message
            if(nxml.documentElement.nodeName == "parsererror") {
                alert("error while parsing" + xml);
            }
            
            for(var day = 0; day < 7; day++) {
                //var cimg = document.getElementById('day'+day+'Img');
                //cimg.src = "";
                //cimg.style.opacity = 0.0;
                var chigh = document.getElementById('dayHigh'+day);
                chigh.innerHTML = "";
                var clow = document.getElementById('dayLow'+day);
                clow.innerHTML = "";
                var cpop = document.getElementById('dayPop'+day);
                cpop.innerHTML = "";
                var cpop = document.getElementById('dayNPop'+day);
                cpop.innerHTML = "";
                var cname = document.getElementById('day'+day);
                cname.innerHTML = "";
            }
            
            var loc = document.getElementById('location');
            loc.style.color = '#DDDDDD';
            loc.warningHTML = "";
            loc.title = "";

            var nl = nxml.documentElement.getElementsByTagName('entry');
			for(var i = 0, day = 0; i < nl.length; i++) {
                var summary = nl[i].getElementsByTagName('title')[0].childNodes[0].nodeValue;
                var currentObservation = nl[i].getElementsByTagName('summary')[0].childNodes[0].nodeValue;

                if(currentObservation.indexOf("Observed at:") > 0) {
                    currentDetails = currentObservation;
                } else {
                    currentDetails = currentDetails + "<br>" + summary + "<br>";
                }
                
                var category = nl[i].getElementsByTagName('category')[0];
                
                if(category.attributes[0].value == "Current Conditions") {
                    var temp = nl[i].getElementsByTagName('title')[0].childNodes[0].nodeValue;
                    temp = temp.substring(temp.indexOf(", ")+2, temp.length - 1);
                    temp = temp.replace(/[^0-9\.-]/g, '');
                    var itemp = parseFloat(temp);
                    if(units == 'i') {
                        itemp = (itemp*9)/5 + 32;
                    }
                    
                    itemp = parseInt(Math.round(itemp));
                    
                    ct.innerHTML = "" + itemp + "º";
                }

                if (category.attributes[0].value == "Warnings and Watches"){
                    var warningText = nl[i].getElementsByTagName('title')[0].childNodes[0].nodeValue;
                    if(warningText.indexOf("No watches") == -1 && warningText.indexOf("No warnings") == -1) {
                        var warningLink = nl[i].getElementsByTagName('link')[0].attributes[1].value;

                        if(warningText.match(/WARNING/)) {
                            loc.style.color = '#FF0000';
                        } else if(warningText.match(/WATCH/)) {
                            loc.style.color = '#FFFF00';
                        } else if(warningText.match(/ADVISORY/) || warningText.match(/SPECIAL WEATHER STATEMENT/)) {
                            loc.style.color = '#707070';
                        }
                        loc.warningHTML = warningLink;
                        if(lang == 'f') {
                            loc.warningHTML = loc.warningHTML.replace(/_e\./, '_f.');
                        }
                        loc.title = warningText;
                    }
                }
                if(category.attributes[0].value != "Weather Forecasts") {
                    continue
                }

                var forecast = nl[i].getElementsByTagName('title')[0].childNodes[0].nodeValue;
                fore = parseFore(forecast, units);
                if(fore) {
                    var cname = document.getElementById('day'+day);
                    cname.innerText = forecast.substring(0, 3);
                    if(lang == 'f') {
                        cname.innerText = translateDOW(cname.innerText);
                    }
                    
                    if(fore.low) {
                        var cpop = document.getElementById('dayNPop'+day);                    
                        var clow = document.getElementById('dayLow'+day);
                        clow.innerText = fore.temp;
                        if(fore.pop) {
                            cpop.innerText = fore.pop;
                        }
                        day++;
                    } else {
                        var cpop = document.getElementById('dayPop'+day);                    
                        var chigh = document.getElementById('dayHigh'+day);
                        chigh.innerText = fore.temp;
                        if(fore.pop) {
                            cpop.innerText = fore.pop;
                        }
                    }
                }
            }
            var sl = document.getElementById('detailsScroll');
            sl.object.content.innerHTML = currentDetails;
		},
		'GET',
        null
    );


	SimpleAJAXCall(
		'http://weather.gc.ca/city/pages/' + currentCity + '_metric_e.html',
		function(xml) {
			var sun = document.getElementById('sunrise');
            var sunx;
            var suny;
            if(lang == 'e') {
                sunx = xml.indexOf("Sunrise");
                suny = xml.indexOf("Sunset");
            } else {
                sunx = xml.indexOf("Lever");
                suny = xml.indexOf("Coucher");
            }
            if(sunx > 0 && suny > 0) {
                // try and get the sunrise/sunset
                var rise = xml.slice(sunx, suny);
                var set = xml.slice(suny, suny+100);
                
                rise = rise.slice(rise.indexOf('<td>')+4, rise.indexOf('</td>'));
                rise = rise.replace(/[ \n\r\tA-Z]/g, '');

                set = set.slice(set.indexOf('<td>')+4, set.indexOf('</td>'));
                set = set.replace(/[ \n\r\tA-Z]/g, '');

                sun.innerHTML = rise +"⟷"+ set;
            } else {
                sun.innerHTML = "";
            }
            			
            var cw = document.getElementById('currentWind');
            var windidx;
            if(lang == 'e') {
                windidx = xml.indexOf("Wind:");
            } else {
                windidx = xml.indexOf("Vent :");
            }
            if(windidx > 0) {
                var wind = xml.substring(windidx, windidx+300);
                wind = wind.substring(wind.indexOf("<dd"), wind.indexOf("</dd>"));
                wind = wind.substring(wind.indexOf(">")+1);
                wind = wind.replace(/<[^>]+>/g, '');
                wind = wind.replace(/  /g, '');
                wind = wind.replace(/[\n\r\t]/g, '');

                cw.innerHTML = wind;
            } else {
                cw.innerHTML = "";
            }
            
			// convert the HTML to an XML DOM object
			xml = getDOMfromXML(xml);
			
            var ci = document.getElementById('currentImg');
            ci.src = "";
            ci.style.opacity = 1.0;
            
            nl = xml.getElementsByTagName('div');
            for(var i = 0; i < nl.length; i++) {
                if(nl[i].id != 'mainContent') {
                    continue;
                }
                var sections = nl[i].getElementsByTagName('section');
                if(sections.length >= 1) {
                    var img = sections[0].getElementsByTagName('img');
                    if(img.length >= 1) {
                        ci.src = "http://www.weather.gc.ca" + img[0].getAttribute('src');
                        ci.style.opacity = 1.0;
                    } else {
                        ci.style.opacity = 0.0;
                    }
                    
                    // find out if we only have today's low as an image
                    var ths = sections[1].getElementsByTagName('th');
                    var offset = 1;
                    if(ths[0].className == "blankcell") {
                        var ctext = document.getElementById('dayHigh0');
                        ctext.innerText = "";
                        offset = 0;
                    }
                    img = sections[1].getElementsByTagName('img');
                    if(img.length == 13) {
                        for(var day = 0; day < 6; day++) {
                            var cnimg = document.getElementById('dayNImg'+day);
                            var cimg = document.getElementById('dayImg'+day);

                            cimg.src = "http://www.weather.gc.ca" + img[2*day].getAttribute('src');                                                                
                            cimg.style.opacity = 1.0;
                            alert(cimg.src);

                            
                            cnimg.src = "http://www.weather.gc.ca" + img[2*day+1].getAttribute('src');
                            cnimg.style.opacity = 1.0;
                            alert(cnimg.src);
                        }
                        var cimg = document.getElementById('dayImg6');
                        cimg.src = "http://www.weather.gc.ca" + img[12].getAttribute('src');                                                                
                        cimg.style.opacity = 1.0;
                    } else if(img.length == 12) {
                        for(var day = 0; day < 6; day++) {
                            var day1 = day+1
                            var cnimg = document.getElementById('dayNImg'+day);
                            var cimg = document.getElementById('dayImg'+day1);

                            cimg.src = "http://www.weather.gc.ca" + img[2*day+1].getAttribute('src');                                                                
                            cimg.style.opacity = 1.0;
                            alert(cimg.src);

                            
                            cnimg.src = "http://www.weather.gc.ca" + img[2*day].getAttribute('src');
                            cnimg.style.opacity = 1.0;
                            alert(cnimg.src);
                        }
                    } else {
                        alert("bad number of images: " + img.length + "; graphics may be skewed");
                    }
                }
            }
		},
		'GET',
        null
    );
}

function detOver(event)
{
	var scr = document.getElementById("detailsScroll");
	var sl = document.getElementById("stackLayout");
		
	sl.object.setCurrentView(scr, 0);
	scr.object.refresh();
}

function detOut(event)
{
	var bottom = document.getElementById("boxBottom");
	var sl = document.getElementById("stackLayout");

	sl.object.setCurrentView(bottom, 1);
}

function windChillOver(event)
{
    var wc = document.getElementById("feelsLike");
	if(wc.innerHTML == '') {
		windChill = '';
		return;
	}
	windChill = wc.innerHTML;
	wc.innerHTML = localizedStrings['Feels Like'];
}

function windChillOut(event)
{
	if(windChill == '')
		return;
    var wc = document.getElementById("feelsLike");
	if(windChill) {
		wc.innerHTML = windChill;
	}
}

function visitVers(event)
{
	var websiteURL = "http://www.mirtchovski.com/code/environment.html";
	widget.openURL(websiteURL);
}

function versionMouseOut(event)
{
	var text = document.getElementById("newVersion");
	text.style.textDecoration = 'none';
}

function versiouMouseOver(event)
{
	var text = document.getElementById("newVersion");
	text.style.textDecoration = 'underline';
}

function setUpdatePrefs(event)
{
	var ui = document.getElementById('updatePopup');
	
	updateInterval = parseInt(ui.options[ui.selectedIndex].value*60000); // value is given in minutes
	setTimer(updateInterval); 
}

function updateHandler()
{
	refresh();
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}


function donation(event)
{
    url = "https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=E2KEFZ3CB4VLQ&lc=CA&item_name=mirtchovski%2ecom%20dashboard%20widgets&item_number=Weather%20Office%20%26%20Environment%20Canada%20Satellite%20Images&currency_code=CAD&bn=PP%2dDonationsBF%3abtn_donate_SM%2egif%3aNonHosted";
    
    widget.openURL(url);
}
